package destination;

require(Exporter);
@ISA=qw(Exporter);

use strict;
use POSIX;
use Gtk;

use vars qw (@EXPORT);

# export functions
@EXPORT= qw (DestinationWindow);


# the data floder
#     where all data files are stored
#     this is the parent folder for :
#                          PAF folder
#                          <queue_name>.dat 
#                          ...  
my $ibmDataDir = '/etc/ibmlp/data';

# PAF folder
my $ibmPafDir = "${ibmDataDir}/pafs";

# the object which contains the translated messages
my $transObj = undef; 

# files which contain messages  ( PAF format )
my $ibmMessagesPaf = "${ibmPafDir}/messages.paf";

# setup message translation
$transObj = new Support::messages($ibmMessagesPaf);


sub ErrButtonOkPressed {

    my $this = shift;
    my $userData = $this->get_user_data;
    my $MainWindow = $userData->{"MainWindow"};
    %$userData=();
    $MainWindow->destroy;

}

sub ErrButtonCancelPressed {
    my $this = shift;
    my $userData = $this->get_user_data;
    my $MainWindow = $userData->{"MainWindow"};
    %$userData=();
    $MainWindow->destroy;

}

# parameters :
#          1. ref to the parent Window
#          2. type of error
#                   0 - nothing special
#                   1 - email address wrong
#                   2 - PIN code wrong
#          3. message1
#          4. message2
#          5. message3
#          6. message4
#          7. message5
sub ErrorsDlg 
{

    my $parentWindow = shift;
    my $errorType    = shift;
    my $label1Text   = shift;
    my $label2Text   = shift;
    my $label3Text   = shift;
    my $label4Text   = shift;
    my $label5Text   = shift;

    ##############################################################
    # create the MAIN WINDOW specific variables
    my $MainWindow=undef;
    my $MainContainer = undef;

    #################################################################
    # MAIN WINDOW controls widgets
    my $label1 = undef;
    my $label2 = undef;
    my $label3 = undef;
    my $label4 = undef;
    my $label5 = undef;

    my $ButtonOk           = undef;
    my $ButtonCancel       = undef;


    my %userData = ();

    #################################################################
    # create the Dialog Window
    $MainWindow = new Gtk::Window -dialog;
    $MainWindow->set_usize(400+150,140+10);
    $MainWindow->set_modal(1);
    $MainWindow->set_policy(0,0,0);
    $MainWindow->set_title($transObj->translate("MSG_ERROR"));

    $MainWindow->show;
    $userData{"MainWindow"}       = $MainWindow;
    $MainWindow->set_user_data(\%userData);


    ################################################################
    # create the container
    $MainContainer = new Gtk::Fixed;
    $MainWindow->add($MainContainer);
    $MainContainer->show;

    ################################################################
    # create the  label 1
    $label1 = new Gtk::Label;
    $label1->set( $label1Text ); # this is NLS
    $label1->set_uposition(8,16);
    $label1->set_usize(384+150,16);
    $label1->set_alignment(0.5,0.5);
    $MainContainer->put($label1,8,16);
    $label1->show;

    ################################################################
    # create the  label 2
    $label2 = new Gtk::Label;
    $label2->set( $label2Text ); # this is NLS
    $label2->set_uposition(8,32);
    $label2->set_usize(384+150,16);
    $label2->set_alignment(0.5,0.5);
    $MainContainer->put($label2,8,32);
    $label2->show;

    ################################################################
    # create the  label 3
    $label3 = new Gtk::Label;
    $label3->set( $label3Text ); # this is NLS
    $label3->set_uposition(8,48);
    $label3->set_usize(384+150,16);
    $label3->set_alignment(0.5,0.5);
    $MainContainer->put($label3,8,48);
    $label3->show;

    ################################################################
    # create the  label 4
    $label4 = new Gtk::Label;
    $label4->set( $label4Text ); # this is NLS
    $label4->set_uposition(8,64);
    $label4->set_usize(384+150,16);
    $label4->set_alignment(0.5,0.5);
    $MainContainer->put($label4,8,64);
    $label4->show;

    ################################################################
    # create the  label 5
    $label5 = new Gtk::Label;
    $label5->set( $label5Text ); # this is NLS
    $label5->set_uposition(8,80);
    $label5->set_usize(384+150,16);
    $label5->set_alignment(0.5,0.5);
    $MainContainer->put($label5,8,80);
    $label5->show;

    if ( $errorType == 0 ) {

	################################################################
	# create the Ok button
	$ButtonOk = new Gtk::Button($transObj->translate("ok"));
	$ButtonOk->set_uposition( 8, 108+10);
	$ButtonOk->set_usize(88,24);
	$MainContainer->put($ButtonOk, 8, 108+10);
   
	$ButtonOk->set_user_data(\%userData);
	$ButtonOk->signal_connect("clicked",\&ErrButtonOkPressed);
	$ButtonOk->show;

	return;
	
    }

    if ( $errorType == 1 ) {

	################################################################
	# create the None button
	$ButtonOk = new Gtk::Button($transObj->translate("none"));
	$ButtonOk->set_uposition( 8, 108+10);
	$ButtonOk->set_usize(88,24);
	$MainContainer->put($ButtonOk, 8, 108+10);
   
	$ButtonOk->set_user_data(\%userData);
	$ButtonOk->signal_connect("clicked",\&ErrButtonOkPressed);
	$ButtonOk->show;

	################################################################
	# create the Cancel button
	$ButtonCancel = new Gtk::Button($transObj->translate("cancel"));
	$ButtonCancel->set_uposition( 104, 108+10);
	$ButtonCancel->set_usize(88,24);
	$MainContainer->put($ButtonCancel, 104, 108+10);
	
	$ButtonCancel->set_user_data(\%userData);
	$ButtonCancel->signal_connect("clicked",\&ErrButtonCancelPressed);
	$ButtonCancel->show;

	return;
    }

    if ( $errorType == 2 ) {

	################################################################
	# create the Ok button
	$ButtonOk = new Gtk::Button($transObj->translate("ok"));
	$ButtonOk->set_uposition( 8, 108+10);
	$ButtonOk->set_usize(88,24);
	$MainContainer->put($ButtonOk, 8, 108+10);
   
	$ButtonOk->set_user_data(\%userData);
	$ButtonOk->signal_connect("clicked",\&ErrButtonOkPressed);
	$ButtonOk->show;

	################################################################
	# create the Cancel button
	$ButtonCancel = new Gtk::Button($transObj->translate("cancel"));
	$ButtonCancel->set_uposition( 104, 108+10);
	$ButtonCancel->set_usize(88,24);
	$MainContainer->put($ButtonCancel, 104, 108+10);
	
	$ButtonCancel->set_user_data(\%userData);
	$ButtonCancel->signal_connect("clicked",\&ErrButtonCancelPressed);
	$ButtonCancel->show;

	return;

    }

}


# parameters :
#             1.  QueueName
#             2.  QueuesObject
#             3.  PrinterObject
#             4.  TranslationObject
#             5.  a ref to a hash which will hold the selections
#DestinationWindow($queueName,queuesObj,printerObj,transObj);
sub DestinationWindow 
{

    #################################################################
    # MAIN WINDOW specific variables
    my $MainWindow=undef;
    my $MainContainer = undef;
    
    #################################################################
    # MAIN WINDOW controls widgets
    my $JobNameLabel       = undef;
    my $JobNameEntry       = undef;

    my $UserNameLabel      = undef;
    my $UserNameEntry      = undef;

    my $DeliveryNameLabel  = undef;
    my $DeliveryComboBox   = undef;
    my $DeliveryComboEntry = undef;

    my $PINcodeLabel       = undef;
    my $PINcodeEntry       = undef;
    my $PINcodeLimitsLabel = undef;

    my $EmailFrame         = undef;
    my $EmailContainer     = undef;

    my $TypeLabel          = undef;
    my $TypeComboBox       = undef;
    my $TypeComboEntry     = undef;

    my $AddressLabel       = undef;
    my $AddressEntry       = undef;

    my $MessageLabel       = undef;
    my $MessageEntry       = undef;

    my $ButtonOk           = undef;
    my $ButtonCancel       = undef;
    my $ButtonDefaults     = undef;

    my %userData           = ();

    $userData{"QueueName"}          = shift;
    $userData{"QueuesObject"}       = shift;
    $userData{"PrinterObject"}      = shift;
    $userData{"TranslationObject"}  = shift;
    $userData{"SendAndSave"}       = shift;


    #################################################################
    # create the Dialog Window
    $MainWindow = new Gtk::Window -dialog;
    $MainWindow->set_usize(434,350);
    $MainWindow->set_modal(1);
    $MainWindow->set_policy(0,0,0);
    $MainWindow->set_title($transObj->translate("destination_title"));
    $MainWindow->show;
    $userData{"MainWindow"}       = $MainWindow;
    $MainWindow->set_user_data(\%userData);
    
    ################################################################
    # create the container
    $MainContainer = new Gtk::Fixed;
    $MainWindow->add($MainContainer);
    $MainContainer->show;

    ################################################################
    # create the job name label
    $JobNameLabel = new Gtk::Label;
    $JobNameLabel->set($transObj->translate("job_name"));
    $JobNameLabel->set_uposition(24,24);
    $JobNameLabel->set_usize(136,24);
    $JobNameLabel->set_alignment(1,0.5);
    $MainContainer->put($JobNameLabel,24,24);
    $JobNameLabel->show;

    ################################################################
    # create the job name entry
    $JobNameEntry = new Gtk::Entry;
    $JobNameEntry->set_uposition(168,24);
    $JobNameEntry->set_usize(224,24);
    $JobNameEntry->set_editable(1); # true
    $JobNameEntry->set_max_length(80);
    $MainContainer->put($JobNameEntry,168,24);
    $JobNameEntry->show;
    $userData{"JobNameEntry"}    = $JobNameEntry;

    ################################################################
    # create the User name label
    $UserNameLabel = new Gtk::Label;
    $UserNameLabel->set($transObj->translate("user_name"));
    $UserNameLabel->set_uposition(24,56);
    $UserNameLabel->set_usize(136,24);
    $UserNameLabel->set_alignment(1,0.5);
    $MainContainer->put($UserNameLabel,24,56);
    $UserNameLabel->show;

    ################################################################
    # create the user name entry
    $UserNameEntry = new Gtk::Entry;
    $UserNameEntry->set_uposition(168,56);
    $UserNameEntry->set_usize(224,24);
    $UserNameEntry->set_editable(1); # true
    $UserNameEntry->set_max_length(16);
    $MainContainer->put($UserNameEntry,168,56);
    $UserNameEntry->show;
    $userData{"UserNameEntry"}     = $UserNameEntry;

    ################################################################
    # create the Delivery name label
    $DeliveryNameLabel = new Gtk::Label;
    $DeliveryNameLabel->set($transObj->translate("delivery"));
    $DeliveryNameLabel->set_uposition(24,88);
    $DeliveryNameLabel->set_usize(136,24);
    $DeliveryNameLabel->set_alignment(1,0.5);
    $MainContainer->put($DeliveryNameLabel,24,88);
    $DeliveryNameLabel->show;

    ################################################################
    # create the Delivery CombBox
    $DeliveryComboBox = new Gtk::Combo;
    $DeliveryComboBox->set_uposition(168,88);
    $DeliveryComboBox->set_usize(224,24);
    $MainContainer->put($DeliveryComboBox,168,88);
    $DeliveryComboBox->show;
    $userData{"DeliveryComboBox"} = $DeliveryComboBox;
    
    $DeliveryComboEntry = $DeliveryComboBox->entry;
    $DeliveryComboEntry->set_editable(0); # false
    $DeliveryComboBox->entry->set_user_data(\%userData);
    $DeliveryComboBox->entry->signal_connect("changed",\&ValidateControls);

    ################################################################
    # create the PIN code label
    $PINcodeLabel = new Gtk::Label;
    $PINcodeLabel->set($transObj->translate("pin_label"));
    $PINcodeLabel->set_uposition(112,120);
    $PINcodeLabel->set_usize(104,24);
    $PINcodeLabel->set_alignment(1,0.5);
    $MainContainer->put($PINcodeLabel,112,120);
    $PINcodeLabel->show;

    ################################################################
    # create the PIN code  entry
    $PINcodeEntry = new Gtk::Entry;
    $PINcodeEntry->set_uposition(224,120);
    $PINcodeEntry->set_usize(56,24);
    $PINcodeEntry->set_editable(1); # true
    $PINcodeEntry->set_max_length(4);
    $MainContainer->put($PINcodeEntry,224,120);
    $PINcodeEntry->show;
    $userData{"PINcodeEntry"}     = $PINcodeEntry;

    ################################################################
    # create the PIN code limits label
    $PINcodeLimitsLabel = new Gtk::Label;
    $PINcodeLimitsLabel->set($transObj->translate("pin_values"));
    $PINcodeLimitsLabel->set_uposition(288,120);
    $PINcodeLimitsLabel->set_usize(96,24);
    $PINcodeLimitsLabel->set_alignment(1,0.5);
    $MainContainer->put($PINcodeLimitsLabel,288,120);
    $PINcodeLimitsLabel->show;

    #################################################################
    # create Email Notification Frame
    $EmailFrame = new Gtk::Frame($transObj->translate("email_notif"));
    $EmailFrame->set_uposition(24,152);
    $EmailFrame->set_usize(368,128);
    $MainContainer->put($EmailFrame,24,152);
    $EmailFrame->show;

    ################################################################
    # create the container
    $EmailContainer = new Gtk::Fixed;
    $EmailFrame->add($EmailContainer);
    $EmailContainer->show;

    ################################################################
    # create the Type label
    $TypeLabel = new Gtk::Label;
    $TypeLabel->set($transObj->translate("type_label"));
    $TypeLabel->set_uposition(0,8);
    $TypeLabel->set_usize(112,24);
    $TypeLabel->set_alignment(1,0.5);
    $EmailContainer->put($TypeLabel,0,8);
    $TypeLabel->show;

    ################################################################
    # create the Type CombBox & get the Entry field from it
    $TypeComboBox = new Gtk::Combo;
    $TypeComboBox->set_uposition(120,8);
    $TypeComboBox->set_usize(232,24);
    $EmailContainer->put($TypeComboBox,120,8);
    $TypeComboBox->show;
    $userData{"TypeComboBox"}     = $TypeComboBox;

    $TypeComboEntry = $TypeComboBox->entry;
    $TypeComboEntry->set_editable(0); # false

    $TypeComboEntry->set_user_data(\%userData);
    $TypeComboEntry->signal_connect("changed",\&ValidateControls);

    ################################################################
    # create the Address label
    $AddressLabel = new Gtk::Label;
    $AddressLabel->set($transObj->translate("address_label"));
    $AddressLabel->set_uposition(0,40);
    $AddressLabel->set_usize(112,24);
    $AddressLabel->set_alignment(1,0.5);
    $EmailContainer->put($AddressLabel,0,40);
    $AddressLabel->show;

    ################################################################
    # create the Address entry
    $AddressEntry = new Gtk::Entry;
    $AddressEntry->set_uposition(120,40);
    $AddressEntry->set_usize(232,24);
    $AddressEntry->set_editable(1); # true
    $AddressEntry->set_max_length(64);
    $EmailContainer->put($AddressEntry,120,40);
    $AddressEntry->show;
    $userData{"AddressEntry"}     = $AddressEntry;

    ################################################################
    # create the Message label
    $MessageLabel = new Gtk::Label;
    $MessageLabel->set($transObj->translate("message_label"));
    $MessageLabel->set_uposition(0,72);
    $MessageLabel->set_usize(112,24);
    $AddressEntry->set_max_length(255);
    $MessageLabel->set_alignment(1,0.5);
    $EmailContainer->put($MessageLabel,0,72);
    $MessageLabel->show;

    ################################################################
    # create the Message entry
    $MessageEntry = new Gtk::Entry;
    $MessageEntry->set_uposition(120,72);
    $MessageEntry->set_usize(232,24);
    $MessageEntry->set_editable(1); # true
    $EmailContainer->put($MessageEntry,120,72);
    $MessageEntry->show;
    $userData{"MessageEntry"}     = $MessageEntry;

    ################################################################
    # create the Ok button
    $ButtonOk = new Gtk::Button($transObj->translate("ok"));
    $ButtonOk->set_uposition(30,310);
    $ButtonOk->set_usize(110,24);
    $MainContainer->put($ButtonOk,20,310);

    $ButtonOk->set_user_data(\%userData);
    $ButtonOk->signal_connect("clicked",\&ButtonOkPressed);
    $ButtonOk->show;


    ################################################################
    # create the Cancel button
    $ButtonCancel = new Gtk::Button($transObj->translate("cancel"));
    $ButtonCancel->set_uposition(160,310);
    $ButtonCancel->set_usize(110,24);
    $MainContainer->put($ButtonCancel,150,310);

    $ButtonCancel->set_user_data(\%userData);
    $ButtonCancel->signal_connect("clicked",\&ButtonCancelPressed);
    $ButtonCancel->show;


    ################################################################
    # create the Defaults button
    $ButtonDefaults = new Gtk::Button($transObj->translate("defaults"));
    $ButtonDefaults->set_uposition(290,310);
    $ButtonDefaults->set_usize(110,24);
    $MainContainer->put($ButtonDefaults,300,310);

    $ButtonDefaults->show;
    $ButtonDefaults->set_user_data(\%userData);
    $ButtonDefaults->signal_connect("clicked",\&LoadDefaultData);
    $ButtonDefaults->show;


    ################################################################
    # load the combo boxes
    &LoadComboBoxes($MainWindow);


    ################################################################
    # load the data from the hash passed as a parameter
    my $SendAndSave = $userData{"SendAndSave"};
    my $printerObj   = $userData{"PrinterObject"};

    $JobNameEntry->set_text($SendAndSave->{"*JobName"});
    $UserNameEntry->set_text($SendAndSave->{"*UserName"});
    $PINcodeEntry->set_text($SendAndSave->{"*PINCode"});
    $AddressEntry->set_text($SendAndSave->{"*EmailAddress"});
    $MessageEntry->set_text($SendAndSave->{"*EmailMessage"});

    my $DeliverySel=$SendAndSave->{"*SendAndSave"};
    my $transDeliverySel = 
	$printerObj->getFeatureOptionTranslation("*SendAndSave",
						 $DeliverySel);
    $DeliveryComboBox->entry->set_text($transDeliverySel);

    my $EmailTypeSel=$SendAndSave->{"*EmailNotification"};
    my $transEmailTypeSel = 
	$printerObj->getFeatureOptionTranslation("*EmailNotification",
						 $EmailTypeSel);
    $TypeComboBox->entry->set_text($transEmailTypeSel);
    
    &ValidateControls($MainWindow);
        
}




sub CancelPressed {
    my $this = shift;
    my $userData = $this->get_user_data;
    my $MainWindow = $userData->{"MainWindow"};
    %$userData=();
    $MainWindow->destroy;
}


sub LoadComboBoxes {
    my $MainWindow = shift;

    my $userData   = $MainWindow->get_user_data;

    my $QueueName  = $userData->{"QueueName"};
    my $QueuesObj  = $userData->{"QueuesObject"};
    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $DeliveryComboBox = $userData->{"DeliveryComboBox"};
    my $TypeComboBox     = $userData->{"TypeComboBox"};

    # fill the Delivery ComboBox with data from PPD file
    my @destItems = $printerObj->enumFeatureOptions("*SendAndSave");
    my @transDestItems = ();
    foreach my $dItem ( @destItems ) {
	# get the translations from PPD file
	my $tdItem = $printerObj->getFeatureOptionTranslation("*SendAndSave",
							      $dItem );
	@transDestItems=(@transDestItems,$tdItem);
    }
    $DeliveryComboBox->set_popdown_strings(@transDestItems);

    # fill the Type ComboBox with all the values read from PPD file
    my @typeItems = $printerObj->enumFeatureOptions("*EmailNotification");
    my @translatedTypeItems = ();
    foreach my $tItem ( @typeItems ) {
	# get the translations from PPD file
	my $ttItem = $printerObj->getFeatureOptionTranslation("*EmailNotification",
							      $tItem );
	@translatedTypeItems=(@translatedTypeItems,$ttItem);
    }
    $TypeComboBox->set_popdown_strings(@translatedTypeItems);


    
}

sub LoadDefaultData {

    my $MainWindow = shift;

    my $userData   = $MainWindow->get_user_data;

    my $QueueName  = $userData->{"QueueName"};
    my $QueuesObj  = $userData->{"QueuesObject"};
    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $SendAndSave     = $userData->{"SendAndSave"};
    my $UserNameEntry    = $userData->{"UserNameEntry"};
    my $JobNameEntry     = $userData->{"JobNameEntry"};
    my $DeliveryComboBox = $userData->{"DeliveryComboBox"};
    my $PINcodeEntry     = $userData->{"PINcodeEntry"};
    my $TypeComboBox     = $userData->{"TypeComboBox"};
    my $AddressEntry     = $userData->{"AddressEntry"};
    my $MessageEntry     = $userData->{"MessageEntry"};


    ###############################################################
    #  THE SEND AND SAVE DEFAULT SETTINGS
    #  THE EMAIL NOTIFICATION DEFAULT SETTINGS
    $JobNameEntry->set_text($transObj->translate("UseAppSetting"));
    $UserNameEntry->set_text($ENV{"USER"});
    $PINcodeEntry->set_text("0000");
    # set the PPD default value for the Delivery Combo Box
    my $defaultDestItem=$printerObj->getFeatureDefault("*SendAndSave");
    my $tdefaultDestItem=$printerObj->getFeatureOptionTranslation("*SendAndSave",
								  $defaultDestItem);
    $DeliveryComboBox->entry->set_text($tdefaultDestItem);

    ###############################################################
    #  THE EMAIL NOTIFICATION DEFAULT SETTINGS
    # set the job name  the address 
    $AddressEntry->set_text("");
    $MessageEntry->set_text("");    
    #set the PPD default value for the email notification type 
    my $defaultTypeItem=$printerObj->getFeatureDefault("*EmailNotification");
    my $tdefaultTypeItem=$printerObj->getFeatureOptionTranslation("*EmailNotification",
								  $defaultTypeItem);
    $TypeComboBox->entry->set_text($tdefaultTypeItem);
    
}


sub ValidateControls {

    my $window = shift;

    my $userData   = $window->get_user_data;

    my $QueueName  = $userData->{"QueueName"};
    my $QueuesObj  = $userData->{"QueuesObject"};
    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $SendAndSave     = $userData->{"SendAndSave"};
    my $UserNameEntry    = $userData->{"UserNameEntry"};
    my $JobNameEntry     = $userData->{"JobNameEntry"};
    my $DeliveryComboBox = $userData->{"DeliveryComboBox"};
    my $PINcodeEntry     = $userData->{"PINcodeEntry"};
    my $TypeComboBox     = $userData->{"TypeComboBox"};
    my $AddressEntry     = $userData->{"AddressEntry"};
    my $MessageEntry     = $userData->{"MessageEntry"};
   
    my $DeliveryString = $DeliveryComboBox->entry->get_text;
    my $DeliverySelection = GetSelectionValue( $printerObj,
					       "*SendAndSave",
					       $DeliveryString);

    if($DeliverySelection ne "Hold" ) {
	$PINcodeEntry->set_editable(0);
    } else {
	$PINcodeEntry->set_editable(1);
    }
 
    my $ETypeString = $TypeComboBox->entry->get_text;
    my $ETypeSelection = GetSelectionValue( $printerObj,
					       "*EmailNotification",
					       $ETypeString);


    if( defined $ETypeSelection ) {
	if($ETypeSelection eq "None" ) {
	    $AddressEntry->set_editable(0);
	    $MessageEntry->set_editable(0);
	} else {
	    $AddressEntry->set_editable(1);
	    $MessageEntry->set_editable(1);
	}
    }

}

sub GetSelectionValue {

    my $printerObj = shift;
    my $feature = shift;
    my $translation = shift;
    my $value;

    my @options=$printerObj->enumFeatureOptions($feature);
    foreach my $option ( @options ) {
	my $trans = $printerObj->getFeatureOptionTranslation($feature,$option);
	if( $trans eq $translation ) {
	    $value = $option;
	    last;
	}
    }
    return $value;
}


sub ButtonCancelPressed {
    my $this = shift;
    my $userData = $this->get_user_data;
    my $MainWindow = $userData->{"MainWindow"};
    %$userData=();
    $MainWindow->destroy;
}



sub ButtonOkPressed {

    my $this = shift;
    my $userData = $this->get_user_data;

    my $MainWindow = $userData->{"MainWindow"};

    my $QueueName  = $userData->{"QueueName"};
    my $QueuesObj  = $userData->{"QueuesObject"};
    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $SendAndSave     = $userData->{"SendAndSave"};
    my $UserNameEntry    = $userData->{"UserNameEntry"};
    my $JobNameEntry     = $userData->{"JobNameEntry"};
    my $DeliveryComboBox = $userData->{"DeliveryComboBox"};
    my $PINcodeEntry     = $userData->{"PINcodeEntry"};
    my $TypeComboBox     = $userData->{"TypeComboBox"};
    my $AddressEntry     = $userData->{"AddressEntry"};
    my $MessageEntry     = $userData->{"MessageEntry"};



    # check if the PIN code is OK 
    # only if Hold Job Until Enter PIN is selected
    my $DeliverySelection=&CheckPIN($MainWindow);
    if (! defined $DeliverySelection ) {
	return;
    }

    # check if the email is written OK
    # only if a Email Type is selected other than "None"
    my $ETypeSelection=&CheckEmailAddress($MainWindow);
    if (! defined  $ETypeSelection ) {
	return;
    }

    # check if is any wrong char in the UserName

    my $UserNameString=&UserNameIsOk($MainWindow);
    if( ! defined $UserNameString  ) {
	return;
    }
    
    # check if is any wrong char in the JobName

    my $JobNameString=&JobNameIsOk($MainWindow);
    if( ! defined $JobNameString  ) {
	return;
    }

    # check if is any wrong char in the Email Message
    my $EmailMessageString=&EmailMessageIsOk($MainWindow);
    if( ! defined $EmailMessageString  ) {
	return;
    }




# if is OK , fill the hash with return values

    $SendAndSave->{"*SendAndSave"}      = $DeliverySelection;
    $SendAndSave->{"*EmailNotification"} = $ETypeSelection;
    $SendAndSave->{"*JobName"}           = $JobNameString;
    $SendAndSave->{"*UserName"}          = $UserNameString;
    $SendAndSave->{"*PINCode"}           = $PINcodeEntry->get_text;
    $SendAndSave->{"*EmailAddress"}      = $AddressEntry->get_text;
    $SendAndSave->{"*EmailMessage"}      = $EmailMessageString;

# exit from the "Destination Dialog" ...
    %$userData=();
    $MainWindow->destroy;
}






sub CheckPIN {

    my $MainWindow = shift;

    my $userData = $MainWindow->get_user_data;

    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $SendAndSave     = $userData->{"SendAndSave"};

    my $PINcodeEntry     = $userData->{"PINcodeEntry"};
    my $DeliveryComboBox = $userData->{"DeliveryComboBox"};


# get the selection of "Destination"
# check if all the fields of "Destination" were filled
    my $DeliveryString = $DeliveryComboBox->entry->get_text;
    my $DeliverySelection = GetSelectionValue( $printerObj,
					       "*SendAndSave",
					       $DeliveryString);


    if($DeliverySelection eq "Hold" ) {
	# check if the PIN was introduced
	$_ = $PINcodeEntry->get_text;
	if(! /\d{4}/ ) {
	    # the format of PIN code is wrong
	    &ErrorsDlg($MainWindow,
		       2,
		       '"'.
		       $PINcodeEntry->get_text.
		       '" '.
		       $transObj->translate("ErrDestPin1"),
		       ,$transObj->translate("ErrDestPin2"),
		       " ",
		       ,$transObj->translate("ErrDestPin3"),
		       ,$transObj->translate("ErrDestPin4"));
	    return undef;
	}
    }

    return $DeliverySelection;
}

sub CheckEmailAddress {

    my $MainWindow = shift;

    my $userData = $MainWindow->get_user_data;

    my $printerObj = $userData->{"PrinterObject"};
    my $TransObj   = $userData->{"TranslationObject"};

    my $SendAndSave     = $userData->{"SendAndSave"};

    my $TypeComboBox     = $userData->{"TypeComboBox"};
    my $AddressEntry     = $userData->{"AddressEntry"};
    

    my $ETypeString = $TypeComboBox->entry->get_text;
    my $ETypeSelection = GetSelectionValue( $printerObj,
					       "*EmailNotification",
					       $ETypeString);


# get the selection of "Email Notification"
# check if all the files of "Email Notification" were filled

    $_ = $AddressEntry->get_text;
    s/^[ ]*//g;
    s/[ ]*$//g;
    my $tempEmailString=$_;

    if($ETypeSelection ne "None" ) {

	# check the email address 

	$_ = $tempEmailString;
	if(! m/^([a-zA-Z0-9_]+(\.|\-)?)+@([a-zA-Z0-9_\-]+\.)+[a-zA-Z0-9_\-]+$/ ) {
	    # the formatemail address  wrong
	    &ErrorsDlg($MainWindow,
		       1,
		       '"'.
		       $tempEmailString.
		       '" '.
		       $transObj->translate("ErrDestMail1"),
		       ,$transObj->translate("ErrDestMail2"),
		       " ",
		       ,$transObj->translate("ErrDestMail3"),
		       ,$transObj->translate("ErrDestMail4"));
	    return undef;
	}
    }

    return $ETypeSelection;
}

sub UserNameIsOk {

    my $MainWindow = shift;
    my $userData = $MainWindow->get_user_data;
    my $TransObj   = $userData->{"TranslationObject"};

    my $UserNameEntry    = $userData->{"UserNameEntry"};

    $_ =  $UserNameEntry->get_text;

    s/\,/ /g; # substitute all , with spaces ( it is not accepted )
    s/\=/ /g; # substitute all = with spaces ( it is not accepted )
    s/\"/ /g; # substitute all " with spaces ( it is not accepted )
    s/\'/ /g; # substitute all ' with spaces ( it is not accepted )

    # elimitate all spaces from begin and end of the string
    s/^[ ]*//g;
    s/[ ]*$//g;

    if (! $_ ) {
	# if the string is NULL than take the user name from
	# environment
	return $ENV{USER};
    }

    return $_;
}

sub JobNameIsOk {

    my $MainWindow = shift;
    my $userData = $MainWindow->get_user_data;
    my $TransObj   = $userData->{"TranslationObject"};

    my $JobNameEntry    = $userData->{"JobNameEntry"};
 
    $_ =  $JobNameEntry->get_text;

    s/\,/ /g; # substitute all , with spaces ( it is not accepted )
    s/\=/ /g; # substitute all = with spaces ( it is not accepted )
    s/\"/ /g; # substitute all " with spaces ( it is not accepted )
    s/\'/ /g; # substitute all ' with spaces ( it is not accepted )

    # elimitate all spaces from begin and end of the string
    s/^[ ]*//g;
    s/[ ]*$//g;

    if( ! $_ ) {
	return $transObj->translate("UseAppSetting");
    }
    return $_;
}


sub EmailMessageIsOk {

    my $MainWindow = shift;
    my $userData = $MainWindow->get_user_data;
    my $TransObj   = $userData->{"TranslationObject"};


    my $printerObj = $userData->{"PrinterObject"};
    
    my $TypeComboBox     = $userData->{"TypeComboBox"};
    
    my $ETypeString = $TypeComboBox->entry->get_text;
    my $ETypeSelection = GetSelectionValue( $printerObj,
					       "*EmailNotification",
					       $ETypeString);

    my $MessageEntry     = $userData->{"MessageEntry"};


    $_ =  $MessageEntry->get_text;

    s/\,/ /g; # substitute all , with spaces ( it is not accepted )
    s/\=/ /g; # substitute all = with spaces ( it is not accepted )
    s/\"/ /g; # substitute all " with spaces ( it is not accepted )
    s/\'/ /g; # substitute all ' with spaces ( it is not accepted )

    

    # elimitate all spaces from begin of the string
    s/^[ ]*//g;

    return $_;
}




