#  
#   COMPONENT_NAME: LINUXDRV
#
#   FUNCTIONS: none
#
#   ORIGINS:
#
#
#   (C) COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#
# PERL package, containing DEFINEs for IBMprntool, IBMnpmenu
# programs
#

# package declaration
package ibm_defs;

require(Exporter);
@ISA = qw(Exporter);


# DEFINE names to export 
@EXPORT = qw($DEF_LPR $DEF_LPR_PRINTER $DEF_LPR_OPTIONS $DEF_TEMP_FILE 
            $DEF_XML_MESSAGES $DEF_PAF_MESSAGES 
            $DEF_XML_QUEUES $DEF_PAF_QUEUES $DEF_NOT_DEFAULT_STR         
            $DEF_ID_DATA_KEY $DEF_DEF_MARK_LEFT $DEF_DEF_MARK_RIGHT      
            @Gpaper_features $Gtranslations_no $Gcurrent_translation 
            $DEF_MAIN_WINDOW_WIDTH 
            $DEF_MAIN_WINDOW_HEIGHT 
            $DEF_SPIN_ADJ_LOWER $DEF_SPIN_ADJ_UPPER 
            $DEF_SPIN_ADJ_STEP_INC $DEF_SPIN_ADJ_PAGE_INC 
            $DEF_SPIN_ADJ_PAGE_SIZE 
            $DEF_BTN_CANCEL_TITLE $DEF_BTN_HELP_TITLE 
            $DEF_HELP_WINDOW_WIDTH $DEF_HELP_WINDOW_HEIGHT 
            $DEF_FILE_WINDOW_WIDTH $DEF_FILE_WINDOW_HEIGHT 
            $DEF_GEN_BUTTON_WIDTH $DEF_GEN_BUTTON_HEIGHT 
            $DEF_IBMPRNTOOL_HELP_FILE $DEF_XML_ROOT $DEF_PAF_ROOT 
            $DEF_XML_EXT $DEF_PAF_EXT $DEF_IBMNPMENU_HELP_FILE 
            $DEF_QUEUE_TYPE_PS $DEF_QUEUE_TYPE_PCL $DEF_QUEUE_TYPE_RAW
            @constraint_xpm);


# keywords for selecting between paper features and the other features
@Gpaper_features                = ("paper","input","output",
                                    "pagesize","pageregion","duplex");

# Used if the PPD files accept more than 1 translations in the
# same file                    
$Gtranslations_no               = 1;
$Gcurrent_translation           = 1;

# IBMprntool main window default dimensions
$DEF_MAIN_WINDOW_WIDTH          = 630;
$DEF_MAIN_WINDOW_HEIGHT         = 450;

# SpinEditBox properties - used to set No. of copies
$DEF_SPIN_ADJ_LOWER             = 1;
$DEF_SPIN_ADJ_UPPER             = 1000;
$DEF_SPIN_ADJ_STEP_INC          = 1;    
$DEF_SPIN_ADJ_PAGE_INC          = 10;
$DEF_SPIN_ADJ_PAGE_SIZE         = 10;

# IBMprntool help window default dimensions
$DEF_HELP_WINDOW_WIDTH          = 400;
$DEF_HELP_WINDOW_HEIGHT         = 300;

# IBMprntool file window default dimensions
$DEF_FILE_WINDOW_WIDTH          = 400;
$DEF_FILE_WINDOW_HEIGHT         = 100;

# IBMprntool buttons default dimensions
$DEF_GEN_BUTTON_WIDTH           = 50;
$DEF_GEN_BUTTON_HEIGHT          = 20;

# some LPR characteristics
$DEF_LPR                        = "lpr ";
$DEF_LPR_PRINTER                = "-P ";
$DEF_LPR_OPTIONS                = "-Z";

# queue types
$DEF_QUEUE_TYPE_PS              = "PS";
$DEF_QUEUE_TYPE_PCL             = "Pcl";
$DEF_QUEUE_TYPE_RAW             = "Raw";
			
# temporary file name
$DEF_TEMP_FILE                  = "/tmp/IBMprntool_jobs";
# XML file extension
$DEF_XML_EXT                    = "xml";
# PAF file extension
$DEF_PAF_EXT                    = "paf";
# paths
$DEF_XML_ROOT                   = "/etc/ibmlp/data/xmls";
$DEF_PAF_ROOT                   = "/etc/ibmlp/data/pafs";
$DEF_XML_QUEUES                 = "/etc/ibmlp/data/xmls/queues.xml";
$DEF_PAF_QUEUES                 = "/etc/ibmlp/data/pafs/queues.paf";      
$DEF_XML_MESSAGES               = "/etc/ibmlp/data/xmls/messages.xml";
$DEF_PAF_MESSAGES               = "/etc/ibmlp/data/pafs/messages.paf";
$DEF_IBMPRNTOOL_HELP_FILE       = "/etc/ibmlp/docs/IBMprntool.help";
$DEF_IBMNPMENU_HELP_FILE        = "/etc/ibmlp/docs/IBMnpmenu.help";

# key strings for internal handling
$DEF_NOT_DEFAULT_STR            = "!_";
$DEF_ID_DATA_KEY                = "ID";
$DEF_DEF_MARK_LEFT              = "<";
$DEF_DEF_MARK_RIGHT             = ">";        


# the stop sign pixmax description for 
# visual constraints
my @constraint_xpm = (
"14 12 4 1",
"       c None s None",
"b      c black",
"X      c white",
"r      c #FF0000",
"XXXXXrrrrXXXXX",
"XXXrrrrrrrrXXX",
"XXrrXXXXXXrrXX",
"XrrXXXXXXrrrrX",
"XrrXXXXXrrrrrX",
"rrXXXXXrrrXXrr",
"rrXXXrrrXXXXrr",
"XrrXrrrXXXXrrX",
"XrrrrrXXXXXrrX",
"XXrrrXXXXXrrXX",
"XXXrrrrrrrrXXX",
"XXXXXrrrrXXXXX"
);

1;
